Type.registerNamespace("Telerik.Web");
Telerik.Web.UI.SliderValueChangeEventArgs=function(_1,_2){
Telerik.Web.UI.SliderValueChangeEventArgs.initializeBase(this);
this._oldValue=_1;
this._newValue=_2;
};
Telerik.Web.UI.SliderValueChangeEventArgs.prototype={get_oldValue:function(){
return this._oldValue;
},get_newValue:function(){
return this._newValue;
}};
Telerik.Web.UI.SliderValueChangeEventArgs.registerClass("Telerik.Web.UI.SliderValueChangeEventArgs",Sys.EventArgs);
Telerik.Web.UI.SliderBeforeValueChangeEventArgs=function(_3,_4){
Telerik.Web.UI.SliderBeforeValueChangeEventArgs.initializeBase(this);
this._oldValue=_3;
this._newValue=_4;
};
Telerik.Web.UI.SliderBeforeValueChangeEventArgs.prototype={get_oldValue:function(){
return this._oldValue;
},get_newValue:function(){
return this._newValue;
}};
Telerik.Web.UI.SliderBeforeValueChangeEventArgs.registerClass("Telerik.Web.UI.SliderBeforeValueChangeEventArgs",Sys.CancelEventArgs);
Telerik.Web.UI.SliderItemType=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.SliderItemType.prototype={None:1,Item:2,Tick:3};
Telerik.Web.UI.SliderItemType.registerEnum("Telerik.Web.UI.SliderItemType",false);
Telerik.Web.UI.SliderTrackPosition=function(){
throw Error.invalidOperation();
};
Telerik.Web.UI.SliderTrackPosition.prototype={Center:1,TopLeft:2,BottomRight:3};
Telerik.Web.UI.SliderTrackPosition.registerEnum("Telerik.Web.UI.SliderTrackPosition",false);
Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.RadSlider=function(_5){
Telerik.Web.UI.RadSlider.initializeBase(this,[_5]);
this._minimumValue=0;
this._maximumValue=100;
this._value=0;
this._orientation=Telerik.Web.UI.Orientation.Horizontal;
this._isHorizontal=true;
this._animationDuration=0.1;
this._useAnimation=true;
this._showDecreaseHandle=true;
this._showIncreaseHandle=true;
this._showDragHandle=true;
this._enabled=true;
this._slideStep=1;
this._smallChange=1;
this._largeChange=0;
this._clickOffset=0;
this._trackMouseWheel=true;
this._length=200;
this._width="";
this._height="";
this._skin="Default";
this._trackMouseDownDone=false;
this._autoPostBack=false;
this._firstValueOffset;
this._wrapperElement=null;
this._dragHandleElement=null;
this._mouseupHandler=null;
this._selectstartHandler=null;
this._animationPending=false;
this._selectstartPending=false;
this._inSlidingMode=false;
this._inRedrawMode=false;
this._dragText="";
this._increaseText="";
this._decreaseText="";
this._uniqueID=null;
this._resizeExtender=null;
this._selectionEnd=0;
this._isSelectionRangeEnabled=false;
this._endDragHandleElement=null;
this._endResizeExtender=null;
this._children=null;
this._childControlsCreated=false;
this._itemType=Telerik.Web.UI.SliderItemType.None;
this._smallTickSize=0;
this._largeTickSize=0;
this._liveDrag=true;
this._liveDragValue;
this._liveDragHandleElement=null;
this._liveDragEndHandleElement=null;
this._trackPosition=Telerik.Web.UI.SliderTrackPosition.Center;
this._isDirectionReversed=false;
this.repaint=this.redraw;
};
Telerik.Web.UI.RadSlider.prototype={updated:function(){
this._value=this._getValueFromIndex(this._value);
var _6=this._value;
if(this._isSelectionRangeEnabled){
this._selectionEnd=this._getValueFromIndex(this._selectionEnd);
var _7=this._selectionEnd;
var _8=this._isDirectionReversed;
if((_6<_7&&_8)||(_6>_7&&!_8)){
this._switchDragHanldes();
var _9=_6;
this._value=_7;
this._selectionEnd=_9;
}
this._setNewValue(this._selectionEnd,false,true);
}
this._setNewValue(this._value,true,true);
Telerik.Web.UI.RadSlider.callBaseMethod(this,"updated");
},initialize:function(){
var _a=this._minimumValue;
if(_a>this._maximumValue){
throw Error.argumentOutOfRange("_minimumValue",_a,"MinimumValue should be smaller than MaximumValue");
}
this._initializeLayout();
this._initializeSlider();
Telerik.Web.UI.RadSlider.callBaseMethod(this,"initialize");
},_createHandleUI:function(_b,_c,_d){
var _e=document.createElement("A");
_e.id=_b;
_e.href="javascript: void(0);";
Sys.UI.DomElement.addCssClass(_e,_d);
_e.title=_c;
_e.onmouseup="this.blur();";
var _f=document.createElement("SPAN");
_f.innerHTML=_c;
_e.appendChild(_f);
return _e;
},_addDragHandleElement:function(_10,_11){
var _12=this._dragText;
var _13="draghandle";
var _14=(_11?"RadSliderEndDrag_":"RadSliderDrag_")+this.get_id();
var _15=this._createHandleUI(_14,_12,_13);
_10.appendChild(_15);
this[(_11?"_endDragHandleElement":"_dragHandleElement")]=_15;
if(!this._liveDrag){
var _16=this._createHandleUI(("liveDrag_"+_14),_12,(_13+" liveDragHandle"));
_10.appendChild(_16);
this[(_11?"_liveDragEndHandleElement":"_liveDragHandleElement")]=_16;
}
},_initializeLayout:function(){
var _17=this.get_element();
_17.style.display="none";
var _18=this.get_id();
var _19=this._isHorizontal;
var _1a=document.createElement("DIV");
_17.parentNode.insertBefore(_1a,_17);
Sys.UI.DomElement.addCssClass(_1a,"radslider");
Sys.UI.DomElement.addCssClass(_1a,("RadSlider_"+this._skin));
var _1b=this._wrapperElement=document.createElement("DIV");
_1a.appendChild(_1b);
_1b.id="RadSliderWrapper_"+_18;
_1b.setAttribute("unselectable","on");
var _1c=parseInt(this._width);
if(!isNaN(_1c)&&(_1c>0)){
_1b.style.width=_1c+"px";
}
var _1d=parseInt(this._height);
if(!isNaN(_1d)&&(_1d>0)){
_1b.style.height=_1d+"px";
}
Sys.UI.DomElement.addCssClass(_1b,((_19)?"horizontal":"vertical"));
if(!this._enabled){
Sys.UI.DomElement.addCssClass(_1b,"disabled");
}
var _1e=this._itemType;
if(_1e!=Telerik.Web.UI.SliderItemType.None){
var _1f=this._trackPosition;
var _20=(_19)?"rslMiddle":"rslCenter";
if(_1f==Telerik.Web.UI.SliderTrackPosition.TopLeft){
_20=(_19)?"rslTop":"rslLeft";
}else{
if(_1f==Telerik.Web.UI.SliderTrackPosition.BottomRight){
_20=(_19)?"rslBottom":"rslRight";
}
}
Sys.UI.DomElement.addCssClass(_1b,_20);
}
var _21=this._showIncreaseHandle;
var _22=this._showDecreaseHandle;
if(_22){
var _23=this._decreaseHandleElement=this._createHandleUI(("RadSliderDecrease_"+_18),this._decreaseText,"handle decrease");
_1b.appendChild(_23);
}
var _24=this._trackElement=document.createElement("DIV");
_24.setAttribute("unselectable","on");
_24.id="RadSliderTrack_"+_18;
Sys.UI.DomElement.addCssClass(_24,"track");
if(!_22){
_24.style[this._getLocationProperty()]="0px";
}
_1b.appendChild(_24);
var _25=this._selectedRegionElement=document.createElement("DIV");
_25.setAttribute("unselectable","on");
_25.id="RadSliderSelected_"+_18;
Sys.UI.DomElement.addCssClass(_25,"selectedregion");
_25.innerHTML="<!-- -->";
_24.appendChild(_25);
if(this._showDragHandle){
this._addDragHandleElement(_24);
if(this._isSelectionRangeEnabled){
this._addDragHandleElement(_24,true);
}
}
if(_21){
var _23=this._increaseHandleElement=this._createHandleUI(("RadSliderIncrease_"+_18),this._increaseText,"handle increase");
_1b.appendChild(_23);
}
var _26=(_21)?this._getIncreaseHandleBounds().width:0;
var _27=(_22)?this._getDecreaseHandleBounds().width:0;
var _28=this.get_length()-_27-_26;
var _29=$telerik.getBounds(_24);
var _2a=(_19)?_28:_29.width;
var _2b=(!_19)?_28:_29.height;
if(_2a>0&&_2b>0){
$telerik.setSize(_24,{width:_2a,height:_2b});
}
if(_1e==Telerik.Web.UI.SliderItemType.Tick){
this._firstValueOffset=0;
}else{
this._firstValueOffset=-Math.floor(this._getHalfDragHandleSize());
}
},_initializeSlider:function(){
if(this._enabled){
this._initializeEventHandlers();
this._initializeAnimation();
var _2c=this._liveDrag;
var _2d={};
var _2e=($telerik.isIE)?"hand":"pointer";
var _2f=_2c?this._dragHandleElement:this._liveDragHandleElement;
if(_2f){
_2d[_2e]=_2f;
this._resizeExtender=new Telerik.Web.UI.ResizeExtender(this,_2f,_2d,null,null,_2e,false);
this._resizeExtender.set_hideIframes(false);
}
var _30=_2c?this._endDragHandleElement:this._liveDragEndHandleElement;
if(_30){
_2d={};
_2d[_2e]=_30;
this._endResizeExtender=new Telerik.Web.UI.ResizeExtender(this,_30,_2d,null,null,_2e,false);
this._endResizeExtender.set_hideIframes(false);
}
}
if(!this._inRedrawMode){
this.raiseEvent("loaded");
}
},_initializeEventHandlers:function(){
this._selectstartHandler=Function.createDelegate(this,this._onSelectStart);
this._mouseupHandler=Function.createDelegate(this,this._onMouseUp);
$addHandler(document,"mouseup",this._mouseupHandler);
var _31=this._trackElement;
$addHandlers(_31,{"mousedown":this._onTrackMouseDown},this);
if(this._trackMouseWheel&&!this._isSelectionRangeEnabled){
$addHandlers(_31,{"mousewheel":this._onMouseWheel},this);
if($telerik.isFirefox){
$addHandlers(_31,{"DOMMouseScroll":this._onMouseWheel},this);
}
}
if(this._showDecreaseHandle){
$addHandlers(this._decreaseHandleElement,{"mousedown":this._onDecreaseMouseDown},this);
}
if(this._showIncreaseHandle){
$addHandlers(this._increaseHandleElement,{"mousedown":this._onIncreaseMouseDown},this);
}
},dispose:function(){
this._disposeHandlers();
this._disposeAnimation();
this._disposeSlider();
Telerik.Web.UI.RadSlider.callBaseMethod(this,"dispose");
},_disposeSlider:function(){
if(this._resizeExtender){
this._resizeExtender.dispose();
this._resizeExtender=null;
}
if(this._endResizeExtender){
this._endResizeExtender.dispose();
this._endResizeExtender=null;
}
clearTimeout(this._increaseMDownInterval);
clearTimeout(this._decreaseMDownInterval);
clearTimeout(this._mDownInterval);
this._dragHandleElement=null;
this._endDragHandleElement=null;
this._decreaseHandleElement=null;
this._increaseHandleElement=null;
this._trackElement=null;
this._selectedRegionElement=null;
this._liveDragHandleElement=null;
this._liveDragEndHandleElement=null;
},_disposeHandlers:function(){
try{
$clearHandlers(this._trackElement);
if(this._listElement){
$clearHandlers(this._listElement);
}
$clearHandlers(this._decreaseHandleElement);
$clearHandlers(this._increaseHandleElement);
$clearHandlers(this._selectedRegionElement);
$removeHandler(document,"mouseup",this._mouseupHandler);
this._mouseupHandler=null;
this._selectstartHandler=null;
}
catch(e){
}
},onDragStart:function(_32){
var _33=_32.element;
if(isNaN(parseInt(_33.style.left))){
_33.style.left="0";
}
if(isNaN(parseInt(_33.style.top))){
_33.style.top="0";
}
if(!this._liveDrag){
Sys.UI.DomElement.removeCssClass(_33,"liveDragHandle");
Sys.UI.DomElement.addCssClass(_33,"liveDragHandleActive");
_33=(_33.id=="liveDrag_"+this._dragHandleElement.id)?this._dragHandleElement:this._endDragHandleElement;
}
this._handleInSlidingMode=_33;
this._valueOnSlideStart=this._getActiveDragHandleValue(this._updateSelectionStart(null,_33));
if(!this._liveDrag){
this._liveDragValue=this._valueOnSlideStart;
}
this._inSlidingMode=true;
var _34=this._cachedDragHandleBounds=$telerik.getBounds(_33);
var _35=$telerik.getBounds(this._trackElement);
var _36=this._isHorizontal;
var _37=this._firstValueOffset;
this._cachedSliderBounds=new Sys.UI.Bounds((_36?_37:0),(!_36?_37:0),((_36)?(_35.width-2*_37):_34.width),((!_36)?(_35.height-2*_37):_34.height));
this.raiseEvent("slideStart");
return true;
},onDragEnd:function(_38){
var _39=_38.element;
var _3a=this._handleInSlidingMode;
var _3b=this._updateSelectionStart(null,_3a);
if(!this._liveDrag){
Sys.UI.DomElement.removeCssClass(_39,"liveDragHandleActive");
Sys.UI.DomElement.addCssClass(_39,"liveDragHandle");
var _3c=this._liveDragValue;
var _3d=this._calculateDragHandleOffset(_3c);
var _3e=this._getLocationProperty();
var _3f=this._setActiveDragHandleValue(_3c,_3b);
if(!_3f){
_3a.style[_3e]=_3d+"px";
this._updateSelectedRegion(_3a,_3d);
}else{
this._updateRelativeLiveDragHandlePosition(_3a);
}
}
this._cachedSliderBounds=null;
this._cachedDragHandleBounds=null;
this._handleInSlidingMode=null;
this._inSlidingMode=false;
this.raiseEvent("slideEnd");
if(this._autoPostBack&&this._valueOnSlideStart!=this._getActiveDragHandleValue(_3b)){
this._raiseValueChangedServerEvent();
}
},onDrag:function(_40){
var _41=this._cachedDragHandleBounds;
var _42=this._cachedSliderBounds;
if(_42.width<1||_42.height<1){
return false;
}
_40.width=_41.width;
_40.height=_41.height;
var _43=Telerik.Web.UI.ResizeExtender.containsBounds(_42,_40);
if(!_43){
if(_40.x<=_42.x){
_40.x=_42.x;
}else{
if(_42.x+_42.width<=_40.x+_41.width){
_40.x=_42.x+_42.width-_41.width;
}
}
if(_40.y<=_42.y){
_40.y=_42.y;
}else{
if(_42.y+_42.height<=_40.y+_41.height){
_40.y=_42.y+_42.height-_41.height;
}
}
_43=true;
}
var _44=_40.element;
var _45=this._updateSelectionStart(null,_44);
var _46=this._calcValue(null,null,_40,_45);
var _47=this._calculateDragHandleOffset(_46);
_40[this._getPointProperty()]=_47;
var _48=this._liveDrag;
if(_48&&this._getActiveDragHandleValue(_45)!=_46){
var _49=this._setActiveDragHandleValue(_46,_45);
if(_49){
_43=false;
}else{
this._updateSelectedRegion(_44,_47);
}
}else{
if(!_48&&this._liveDragValue!=_46){
this._liveDragValue=_46;
}else{
_43=false;
}
}
this.raiseEvent("slide");
return _43;
},_initializeAnimation:function(){
if(this._showDragHandle){
var fps=100;
var _4b=Function.createDelegate(this,this._onDragHandleAnimationEnded);
this._dragHandleAnimation=new Telerik.Web.Animation.LengthAnimation(this._dragHandleElement,this._animationDuration,fps,"style");
this._dragHandleAnimation.add_ended(_4b);
if(this._isSelectionRangeEnabled){
this._dragHandleEndAnimation=new Telerik.Web.Animation.LengthAnimation(this._endDragHandleElement,this._animationDuration,fps,"style");
this._dragHandleEndAnimation.add_ended(_4b);
}
}
this._selectedRegionAnimation=new Telerik.Web.UI.Animations.SimpleResizeAnimation(this,this._animationDuration,null,this._selectedRegionElement);
},_disposeAnimation:function(){
if(this._dragHandleAnimation){
this._dragHandleAnimation.dispose();
this._dragHandleAnimation=null;
}
if(this._dragHandleEndAnimation){
this._dragHandleEndAnimation.dispose();
this._dragHandleEndAnimation=null;
}
if(this._selectedRegionAnimation){
this._selectedRegionAnimation.dispose();
this._selectedRegionAnimation=null;
}
},_getSelectionAnimationStartBounds:function(){
return this._getSelectedRegionBounds();
},_getSelectionAnimationEndBounds:function(_4c,_4d){
var _4e=this._getSelectedRegionBounds();
var _4f=Math.floor(_4c+this._getHalfDragHandleSize());
var _50=this._getSizeProperty();
var _51=this._getPointProperty();
if(this._isSelectionRangeEnabled){
var _52=_4e[_51];
var _53=_52+_4e[_50];
if(_4d){
_4e[_51]=_4f;
_52=_4f;
}else{
_53=_4f;
}
_4f=_53-_52;
}else{
if(this._isDirectionReversed){
_4e[_51]=_4f;
_4f=this._getTrackBounds().width-_4f;
}
}
_4e[_50]=_4f;
return _4e;
},_onDragHandleAnimationEnded:function(){
this._updateRelativeLiveDragHandlePosition(this._handleInSlidingMode);
},_createChildControls:function(){
if(!this._children){
this._children=new Telerik.Web.UI.RadSliderItemCollection(this);
}
var _54=this.get_itemData();
if(!_54||_54.length==0){
if(this._itemType==Telerik.Web.UI.SliderItemType.Tick){
this._calculateTickSize();
if(this._largeChange>0){
this._calculateTickSize(true);
}
}
}else{
this._createChildControlsUI(_54);
}
},_createChildControlsUI:function(_55){
setTimeout(Function.createDelegate(this,function(){
if(!this._listElement){
this._createChildListElement();
}
var _56=this._listElement;
var _57=this._children;
var _58=_55.length;
if(_56.getElementsByTagName("LI").length==_58){
return;
}
var _59=this._isDirectionReversed;
this._childControlsCreated=true;
for(var i=0,_5b=_55.length;i<_5b;i++){
var _5c=new Telerik.Web.UI.RadSliderItem();
_5c._loadFromDictionary(_55[_59?(_58-1-i):i]);
_57.add(_5c);
}
this._setItemsSize();
if(this._itemType==Telerik.Web.UI.SliderItemType.Item){
this._updateSelectedItemsStatus();
}
}),0);
},_createChildListElement:function(){
var _5d=document.createElement("ul");
_5d.className="rslItemsWrapper";
_5d.unselectable="on";
if(!this._showDecreaseHandle){
_5d.style[this._getLocationProperty()]="0px";
}
var _5e=this._trackElement;
_5e.parentNode.insertBefore(_5d,_5e);
$addHandlers(_5d,{"mousedown":this._onTrackMouseDown},this);
this._listElement=_5d;
return _5d;
},_logInserted:function(_5f){
},_clearSelection:function(){
var _60=this._children;
for(var i=0,_62=_60.get_count();i<_62;i++){
_60.getItem(i).set_selected(false);
}
},_getItemOffset:function(_63,_64,_65){
var _66=_64;
if(!_66){
_66=this._getUlSize()[this._getSizeProperty()];
}
var _67=this._children.get_count();
var _68=0;
if(this._itemType==Telerik.Web.UI.SliderItemType.Tick){
var _69=this._getDragHandleBounds().width;
var _6a=(_69/2);
_68=_6a+Math.floor((_66-2*_6a)/(2*(_67-1)));
var _6b=_68;
if(Number.isInstanceOfType(_65)){
var _6c=this._calculateDragHandleOffset(_65);
_6b+=(this._getTrackBounds().width-_6c-_69);
}
if(_63==0){
return {startPoint:0,endPoint:_68};
}else{
if(_63==(_67-1)){
return {startPoint:(_66-_6b),endPoint:_66};
}
}
_66-=(_68+_6b);
_67-=2;
_63-=1;
if(_66<0||_67<=0){
return {startPoint:0,endPoint:0};
}
}
var _6d=_63/_67;
var _6e=(_63+1)/_67;
var _6f=parseInt(_6d*_66)+_68;
var _70=parseInt(_6e*_66)+_68;
return {startPoint:_6f,endPoint:_70};
},_checkHitInItem:function(_71,_72){
var _73=this._getItemOffset(_71);
if(_72<_73.startPoint){
if(_71<=0){
return null;
}
return this._checkHitInItem(_71-1,_72);
}else{
if(_72>_73.endPoint){
if(_71>=this._children.get_count()-1){
return null;
}
return this._checkHitInItem(_71+1,_72);
}
}
return _71;
},_getItemFromValue:function(_74){
var _75=this._calculateDragHandleOffset(_74)-this._firstValueOffset;
return this._getItemFromOffset(_75);
},_getItemFromOffset:function(_76){
var _77=this._children;
var _78=_77.get_count();
var _79=this._getItemSize(0)[this._getSizeProperty()];
if(_79>0){
var _7a=Math.floor(_76/_79);
_7a=this._checkHitInItem(_7a,_76);
if(_7a>=_78){
_7a=_78-1;
}
if(_7a>=0){
return _77.getItem(_7a);
}
}
return null;
},_updateSelectedItemsStatus:function(){
var _7b=this._children;
if(_7b.get_count()>0){
this._clearSelection();
var _7c=this._getItemFromValue(this._value);
if(_7c){
_7c.set_selected(true);
}
if(this._isSelectionRangeEnabled){
var _7d=this._getItemFromValue(this._selectionEnd);
if(_7d){
_7d.set_selected(true);
}
}
}
},_getUlSize:function(){
var _7e=this._trackElement;
var _7f=$telerik.getSize(_7e);
var _80=_7f;
var _81=this._isHorizontal;
var _82=parseInt(_81?this._height:this._width);
var _83=this._trackPosition;
var _84=_83==Telerik.Web.UI.SliderTrackPosition.TopLeft;
if(_84||_83==Telerik.Web.UI.SliderTrackPosition.BottomRight){
_82-=_7f[_81?"height":"width"];
var _85=_81?(_84?"marginTop":"marginBottom"):(_84?"marginLeft":"marginRight");
var _86=parseInt($telerik.getCurrentStyle(_7e,_85));
if(!isNaN(_86)){
_82-=_86;
}
var _87=parseInt($telerik.getCurrentStyle(this._listElement,_85));
if(!isNaN(_87)){
_82-=_87;
}
}
if(_82>=0){
_80[_81?"height":"width"]=_82;
}
return _80;
},_getItemSize:function(_88,_89,_8a){
var _8b=_89;
if(!_8b){
_8b=this._getUlSize();
}
var _8c={width:_8b.width,height:_8b.height};
var _8d=this._getSizeProperty();
var _8e=this._getItemOffset(_88,_8b[_8d],_8a);
_8c[_8d]=_8e.endPoint-_8e.startPoint;
return _8c;
},_setItemsSize:function(){
var _8f=this._children;
var _90=_8f.get_count();
if(_90==0){
return;
}
var _91=(this._itemType==Telerik.Web.UI.SliderItemType.Tick);
var _92=this._isHorizontal;
var _93=this._getSizeProperty();
var _94=null;
if(_91){
var _95=_8f.getItem(_90-1).get_isSmallTick();
var _96=this._maximumValue;
var _97=((_96-this._minimumValue)%(_95?this._smallChange:this._largeChange));
var _98=(_97!=0);
if(_98){
_94=(_96-_97);
}
}
var _99=this._getUlSize();
var _9a=0;
var _9b=0;
for(var _9c=0;_9c<_90;_9c++){
_9b=this._getItemSize(_9c,_99,_94);
var _9d=_8f.getItem(_9c).get_element();
$telerik.setSize(_9d,_9b);
if(_9c==0){
_9a=_9b[_93];
}
if(!_92&&_91&&(_9c>0||_9c<_90-1)){
var _9e=_9d.getElementsByTagName("SPAN");
var _9f=Math.max(_9b[_93],12)+"px";
for(var i=0,_a1=_9e.length;i<_a1;i++){
_9e[i].style.lineHeight=_9f;
}
}
}
this._setEndTicksBackgroundPosition(_9a);
},get_childListElement:function(){
var _a2=this._listElement;
if(!_a2){
_a2=this._createChildListElement();
}
return _a2;
},get_selectedItems:function(){
var _a3=this._children;
var _a4={};
for(var i=0,_a6=_a3.get_count();i<_a6;i++){
var _a7=_a3.getItem(i);
if(_a7.get_selected()){
_a4[_a4.length]=_a3[i];
}
if(_a4.length==2){
break;
}
}
return _a4;
},_calculateDragHandleOffset:function(_a8){
var _a9=this._minimumValue;
var _aa=this._maximumValue;
var _ab=this._getTrackBounds();
var _ac=this._firstValueOffset;
if(_ac==0){
_ab.width=(_ab.width-this._getDragHandleBounds().width);
}
var _ad=_aa-_a9;
var _ae=(_a8-_a9)/_ad;
var _af;
if(this._isDirectionReversed){
_ae=1-_ae;
_a8=_aa+_a9-_a8;
}
var _b0=parseInt(_ae*(_ab.width));
var _af=(_a8==_a9)?_ac:(_a8==_aa)?(_ab.width+_ac):_b0+_ac;
return _af;
},_getBoundsInternal:function(_b1){
var _b2=$telerik.getBounds(_b1);
if(this._orientation==Telerik.Web.UI.Orientation.Vertical){
_b2={x:_b2.y,y:_b2.x,height:_b2.width,width:_b2.height,right:_b2.right,bottom:_b2.bottom,location:{x:_b2.y,y:_b2.x},size:{width:_b2.height,height:_b2.width}};
}
return _b2;
},_getHalfDragHandleSize:function(){
return (this._getDragHandleBounds().width/2);
},_getTrackBounds:function(){
return this._getBoundsInternal(this._trackElement);
},_getSelectedRegionBounds:function(){
var _b3=$telerik.getContentSize(this._selectedRegionElement);
_b3.y=0;
_b3.x=0;
var _b4=this._isSelectionRangeEnabled;
if(_b4||(!_b4&&this._isDirectionReversed)){
var _b5=this._getElementLocation(this._selectedRegionElement);
_b3[this._getPointProperty()]=_b5;
}
return _b3;
},_getSelectedRegionPoints:function(){
var _b6=this._getSelectedRegionBounds();
var _b7=_b6[this._getPointProperty()];
var _b8=_b7+_b6[this._getSizeProperty()];
return {startPoint:_b7,endPoint:_b8};
},_getDragHandleBounds:function(_b9){
if(!this._showDragHandle){
var _ba={x:0,y:0,height:0,width:0,right:0,bottom:0,location:{x:0,y:0},size:{width:0,height:0}};
return _ba;
}
var _bb=_b9;
if(!_bb){
_bb=this._dragHandleElement;
if(this._isSelectionRangeEnabled&&this._handleInSlidingMode){
_bb=this._handleInSlidingMode;
}
}
return this._getBoundsInternal(_bb);
},_getDecreaseHandleBounds:function(){
return this._getBoundsInternal(this._decreaseHandleElement);
},_getIncreaseHandleBounds:function(){
return this._getBoundsInternal(this._increaseHandleElement);
},_getLocationProperty:function(){
if(!this._locationProperty){
this._locationProperty=this._isHorizontal?"left":"top";
}
return this._locationProperty;
},_updateLocationProperty:function(){
this._locationProperty=this._isHorizontal?"left":"top";
},_getSizeProperty:function(){
if(!this._sizeProperty){
this._sizeProperty=this._isHorizontal?"width":"height";
}
return this._sizeProperty;
},_updateSizeProperty:function(){
this._sizeProperty=this._isHorizontal?"width":"height";
},_getPointProperty:function(){
if(!this._pointProperty){
this._pointProperty=this._isHorizontal?"x":"y";
}
return this._pointProperty;
},_updatePointProperty:function(){
this._pointProperty=this._isHorizontal?"x":"y";
},_doSmallStep:function(_bc){
var _bd=this._smallChange;
var _be=this._isDirectionReversed;
if((!_bc&&!_be)||(_bc&&_be)){
_bd*=-1;
}
this._animationPending=true;
var _bf=true;
if(this._isSelectionRangeEnabled&&_bc){
_bf=false;
}
var _c0=this._getActiveDragHandleValue(_bf)+_bd;
_c0=this._calcValue(_c0,null,null,_bf);
this._setHandlePosition(_c0,null,_bf);
},_calcValue:function(_c1,_c2,_c3,_c4){
var _c5;
var _c6=this._minimumValue;
var _c7=this._maximumValue;
var _c8=(_c4?this._dragHandleElement:this._endDragHandleElement);
if(_c1!=null){
if(!Number.isInstanceOfType(_c1)){
try{
_c1=parseFloat(_c1);
}
catch(ex){
_c1=Number.NaN;
}
}
if(isNaN(_c1)){
_c1=_c6;
}
_c5=(_c1<_c6)?_c6:(_c1>_c7)?_c7:_c1;
}else{
var _c9=this._getTrackBounds();
var _ca=this._getDragHandleBounds(_c8);
if(_c3){
_ca.x=(_c3[this._getPointProperty()])+_c9.x;
}
var _cb=this._firstValueOffset;
var _cc=(_c2!=null)?_c2:_ca.x-_cb-_c9.x;
if(_cb==0){
_c9.width=(_c9.width-_ca.width);
}
var _cd=_cc/_c9.width;
if(this._isDirectionReversed){
_cc=_c9.width-_cc;
_cd=1-_cd;
}
_c5=(_cc==0)?_c6:(_cc==_c9.width)?_c7:_c6+_cd*(_c7-_c6);
}
_c5=this._getNearestStepValue(_c5);
_c5=(_c5<_c6)?_c6:(_c5>_c7)?_c7:_c5;
if(this._children&&this._children.get_count()>0&&(this._itemType==Telerik.Web.UI.SliderItemType.Item)){
var _ce=this._smallChange;
var _cf=this._getItemFromOffset(_cc);
if(_cf){
_c5=this._getValueFromIndex(_cf.get_index());
}else{
if(_c5%2==0){
if(_c5<this._getActiveDragHandleValue(_c4)){
_c5-=_ce;
}else{
_c5+=_ce;
}
_c5=(_c5<_c6)?_c6+_ce:(_c5>_c7)?_c7-_ce:_c5;
}
}
}
return _c5;
},_setHandlePosition:function(_d0,_d1,_d2,_d3){
if(!_d3&&this.raise_beforeValueChange(this._getActiveDragHandleValue(_d2),_d0)){
return;
}
var _d4=_d1;
if(!_d4){
_d4=this._handleInSlidingMode;
}
if(this._useAnimation&&this._animationPending){
if(this._animationEnded==false){
return;
}
this._animationEnded=false;
this._selectedRegionAnimation.stop();
var _d5=this._getSelectionAnimationStartBounds();
this._selectedRegionAnimation.set_startBounds(_d5);
var _d6=this._calculateDragHandleOffset(_d0);
var _d7=this._getSelectionAnimationEndBounds(_d6,_d2);
this._selectedRegionAnimation.set_endBounds(_d7);
this._selectedRegionAnimation.onShowEnd=function(){
var _d8=this.controller;
_d8._setActiveDragHandleValue(_d0,_d2,false);
_d8._animationEnded=true;
};
this._selectedRegionAnimation.play();
if(this._showDragHandle){
var _d9=_d2?this._dragHandleAnimation:this._dragHandleEndAnimation;
var _da=this._getTrackBounds();
var _db=this._getDragHandleBounds(_d4);
var _dc=_db.x-_da.x;
_d9.stop();
_d9.set_startValue(_dc);
_d9.set_endValue(_d6);
_d9.set_propertyKey(this._getLocationProperty());
_d9.play();
}
this._animationPending=false;
}else{
var _d6=this._calculateDragHandleOffset(_d0);
if(this._showDragHandle){
_d4.style[this._getLocationProperty()]=_d6+"px";
this._updateRelativeLiveDragHandlePosition(_d4);
}
this._setActiveDragHandleValue(_d0,_d2,false);
this._updateSelectedRegion(_d4,_d6,_d2);
}
},_getNearestStepValue:function(_dd){
var _de=this._minimumValue;
var _df=this._maximumValue;
var _e0=_df-_de;
if(_e0==0){
return _dd;
}
if(_dd>=_df){
return _df;
}
if(_dd<=_de){
return _de;
}
_dd-=_de;
var _e1=this._smallChange;
var _e2=_dd%_e1;
if(_e2==0){
return (_dd+_de);
}
var _e3=_e1-_e2;
if(_e2<_e1/2){
_e3=-1*_e2;
}
var _e4=_dd+_e3+_de;
return _e4;
},_getRelativeLiveDragHandle:function(_e5){
if(this._liveDrag||!this._showDragHandle){
return null;
}
if(this._updateSelectionStart(null,_e5)){
return this._liveDragHandleElement;
}
return this._liveDragEndHandleElement;
},_updateRelativeLiveDragHandlePosition:function(_e6){
if(this._liveDrag||!this._showDragHandle){
return;
}
if(_e6){
var _e7=this._getRelativeLiveDragHandle(_e6);
if(_e7){
var _e8=this._getLocationProperty();
_e7.style[_e8]=_e6.style[_e8];
}
}else{
if(this._dragHandleElement){
this._updateRelativeLiveDragHandlePosition(this._dragHandleElement);
if(this._isSelectionRangeEnabled&&this._endDragHandleElement){
this._updateRelativeLiveDragHandlePosition(this._endDragHandleElement);
}
}
}
},_getNearestDragHandle:function(_e9){
var _ea=this._dragHandleElement;
if(this._isSelectionRangeEnabled&&_e9){
var _eb=this._getSelectedRegionPoints();
var _ec=_eb.endPoint;
if((Math.abs(_e9-_eb.startPoint)>Math.abs(_e9-_ec))||_e9>_ec){
_ea=this._endDragHandleElement;
}
}
return _ea;
},_getElementLocation:function(_ed){
var _ee=this._getLocationProperty();
var _ef=parseInt(_ed.style[_ee]);
if(isNaN(_ef)){
_ef=0;
}
return _ef;
},_getActiveDragHandleValue:function(_f0){
var _f1=_f0?this._dragHandleElement:this._endDragHandleElement;
if(!_f1&&this._showDragHandle){
return this._minimumValue;
}
var _f2=(_f0!=null)?_f0:this._updateSelectionStart(null,dragHandle);
if(_f2){
return this._value;
}else{
return this._selectionEnd;
}
},_setActiveDragHandleValue:function(_f3,_f4,_f5){
var _f6=_f4?this._dragHandleElement:this._endDragHandleElement;
if(!_f6&&this._showDragHandle){
return;
}
var _f7=this._getActiveDragHandleValue(_f4);
if(_f5!=false&&this.raise_beforeValueChange(_f7,_f3)){
return true;
}
var _f8=this._isDirectionReversed;
var _f9=this._isSelectionRangeEnabled;
if(_f4){
if((_f3>this._selectionEnd&&_f9&&!_f8)||(_f3<this._selectionEnd&&_f9&&_f8)){
this._value=this._selectionEnd;
var _fa=this._calculateDragHandleOffset(this._value);
this._selectedRegionElement.style[this._getLocationProperty()]=_fa+this._getHalfDragHandleSize()+"px";
this._switchDragHanldes();
this._selectionEnd=_f3;
}else{
this._value=_f3;
}
}else{
if((_f3<this._value&&_f9&&!_f8)||(_f3>this._value&&_f9&&_f8)){
this._selectionEnd=this._value;
this._selectedRegionElement.style[this._getSizeProperty()]="0px";
this._switchDragHanldes();
this._value=_f3;
}else{
this._selectionEnd=_f3;
}
}
if(this._itemType==Telerik.Web.UI.SliderItemType.Item){
this._updateSelectedItemsStatus();
}
this.updateClientState();
if(_f3!=_f7){
this.raise_valueChange(_f7,_f3);
if(!this._inSlidingMode&&this._autoPostBack){
this._raiseValueChangedServerEvent();
}
}
},_setNewValue:function(_fb,_fc,_fd){
if(isNaN(parseInt(_fb,10))){
return;
}
var _fe=this._minimumValue;
var _ff=this._maximumValue;
if(_fb<_fe){
_fb=_fe;
}else{
if(_fb>_ff){
_fb=_ff;
}
}
if(!this._initialized){
_fb=this._getNearestStepValue(_fb);
this[_fc?"_value":"_selectionEnd"]=_fb;
return;
}
if(this._isSelectionRangeEnabled){
var _100=this._isDirectionReversed;
var _101=this._value;
var _102=this._selectionEnd;
if((_fb<_101&&!_fc&&!_100)||(_fb>_101&&!_fc&&_100)){
_fc=true;
}else{
if((_fb>_102&&_fc&&!_100)||(_fb<_102&&_fc&&_100)){
_fc=false;
}
}
}
var _103=_fb;
_103=this._calcValue(_fb,null,null,_fc);
_103=_103.toFixed(0);
if(!Number.isInstanceOfType(_103)){
try{
_103=parseFloat(_103);
}
catch(ex){
_103=Number.NaN;
}
}
var _104=this[_fc?"_dragHandleElement":"_endDragHandleElement"];
this._setHandlePosition(_103,_104,_fc,_fd);
},_getIndexFromValue:function(_105){
var _106=this._children;
if(!_106){
return _105;
}
var _107=_106.get_count();
if(_107==0){
_107=this._itemData?this._itemData.length:0;
}
if(_107>0&&(this._itemType==Telerik.Web.UI.SliderItemType.Item)){
var _108=this._minimumValue;
var _109=_107-1;
_105=(_105-this._smallChange)/2;
_105=(_105<_108)?_108:((_105>_109)?_109:_105);
}
return _105;
},_getValueFromIndex:function(_10a){
var _10b=this._children;
if(!_10b){
return _10a;
}
var _10c=_10b.get_count();
if(_10c==0){
_10c=this._itemData?this._itemData.length:0;
}
if(_10c>0&&(this._itemType==Telerik.Web.UI.SliderItemType.Item)){
var _10d=this._smallChange;
var _10e=this._minimumValue;
var _10f=_10c*2-_10d;
_10a=(2*_10a)+_10d;
_10a=(_10a<_10e)?_10e:((_10a>_10f)?_10f:_10a);
}
return _10a;
},_switchDragHanldes:function(){
if(!this._isSelectionRangeEnabled){
return;
}
var _110=this._dragHandleElement;
this._dragHandleElement=this._endDragHandleElement;
this._endDragHandleElement=_110;
if(!this._liveDrag){
_110=this._liveDragHandleElement;
this._liveDragHandleElement=this._liveDragEndHandleElement;
this._liveDragEndHandleElement=_110;
}
_110=this._dragHandleAnimation;
this._dragHandleAnimation=this._dragHandleEndAnimation;
this._dragHandleEndAnimation=_110;
_110=null;
},_updateSelectionStart:function(_111,_112){
if(!this._isSelectionRangeEnabled){
return true;
}
var _113=this._showDragHandle;
if(_113&&_112!=null){
return (_112.id==this._dragHandleElement.id);
}else{
if(!_113&&_111!=null){
var _114=this._getSelectedRegionPoints();
return (Math.abs(_111-_114.startPoint)<Math.abs(_111-_114.endPoint));
}
}
return true;
},_isInIncreaseMode:function(_115,_116){
var _117=this._getSelectedRegionPoints();
var _118=_117.endPoint;
var _119=this._isSelectionRangeEnabled;
var _11a=(!_119&&(_115<_118))||(_119&&(((_115<_118)&&!_116)||((_115<_117.startPoint)&&_116)));
if(this._isDirectionReversed){
if(!_119){
_11a=_115>_117.startPoint;
}else{
_11a=!_11a;
}
}
return _11a;
},_updateSelectedRegion:function(_11b,_11c,_11d){
_11c+=this._getHalfDragHandleSize();
var _11e=_11c;
var _11f=this._selectedRegionElement;
var _120=this._getSizeProperty();
var _121=this._getLocationProperty();
if(this._isSelectionRangeEnabled){
var _122=this._getSelectedRegionBounds();
var _123=_122[this._getPointProperty()];
_11e=_122[_120];
if(_11d||this._updateSelectionStart(_11c,_11b)){
_11f.style[_121]=_11c+"px";
_11e=_11e+(_123-Math.floor(_11c));
}else{
_11e=(Math.floor(_11c)-_123);
}
}else{
if(this._isDirectionReversed){
_11f.style[_121]=_11c+"px";
_11e=this._getTrackBounds().width-Math.floor(_11c);
}
}
if(!isNaN(_11e)&&_11e>=0){
_11f.style[_120]=_11e+"px";
}
},_setEndTicksBackgroundPosition:function(_124){
if(this._itemType==Telerik.Web.UI.SliderItemType.Tick){
var _125=Math.ceil(this._getHalfDragHandleSize());
var _126=Math.floor(this._largeTickSize/2);
var _127=Math.floor(this._smallTickSize/2);
var _128=this._children;
var _129=_128.getItem(0).get_element();
var _12a=_128.getItem(_128.get_count()-1).get_element();
this._setBackgroundPosition(_129,(_125-_126),(_125-_127));
this._setBackgroundPosition(_12a,(_124-(_125+_126)),(_124-(_125+_127)));
}
},_getImageBackgroundPosition:function(){
var _12b=this._trackPosition;
var _12c=this._isHorizontal;
var _12d="center";
if(_12b==Telerik.Web.UI.SliderTrackPosition.TopLeft){
_12d=_12c?"top":"left";
}else{
if(_12b==Telerik.Web.UI.SliderTrackPosition.BottomRight){
_12d=_12c?"bottom":"right";
}
}
return _12d;
},_setBackgroundPosition:function(_12e,_12f,_130){
var _131=(_12e.className.indexOf("largeChange")>-1);
if((_131&&_12f<0)||(!_131&&_130<0)){
return;
}
var _132;
var _133;
if(this._isHorizontal){
_132=(_131?_12f:_130)+"px";
_133=this._getImageBackgroundPosition();
}else{
_133=(_131?_12f:_130)+"px";
_132=this._getImageBackgroundPosition();
}
_12e.style.backgroundPosition=_132+" "+_133;
if(_131){
var _134=this._isHorizontal;
var _135=this._getSizeProperty();
var _136=_12e.getElementsByTagName("SPAN");
var _137=Math.max((2*_12f+this._largeTickSize),12)+"px";
for(var i=0,_139=_136.length;i<_139;i++){
var span=_136[i];
span.style[_135]=_137;
if(!_134){
span.style.lineHeight=_137;
}
}
}
},_calculateTickSize:function(_13b){
var div=document.createElement("DIV");
div.className=_13b?"rslLargeTick":"rslSmallTick";
div.style.position="absolute";
div.style.top="-9999px";
div.style.left="-9999px";
this._wrapperElement.appendChild(div);
var _13d=this._isHorizontal?div.offsetWidth:div.offsetHeight;
div.parentNode.removeChild(div);
if(_13b){
this._largeTickSize=_13d;
}else{
this._smallTickSize=_13d;
}
var _13e=this._largeChange;
if(this._smallTickSize>0&&((this._largeTickSize>0&&_13e>0)||_13e<=0)){
var _13f=this._createItemDataForTicks();
if(!_13f||_13f.length==0){
return;
}
this._createChildControlsUI(_13f);
}
},_createItemDataForTicks:function(){
var _140=[];
var _141=this._largeChange;
var _142=this._smallChange;
var _143=this._maximumValue;
var _144=this._minimumValue;
var _145=(_143-_144)/_142;
var _146=(this._getTrackBounds().width)/_145;
var _147=Math.floor(_146*_141);
_146=Math.floor(_146);
var _148=((_141>0)&&(_147>=this._largeTickSize));
var _149=(_146>=this._smallTickSize);
if(!_148){
_141=Math.abs(_144)+_143+_142;
}
for(var i=_144;i<=_143;i+=_141){
if(_148){
_140[_140.length]={"text":i,"value":i,"tooltip":i,"isLargeTick":true};
}
if(_149){
var j=i+(_148?_142:0);
var _14c=(_148&&((i+_141)<=_143))?(i+_141):(_143+1);
for(;j<_14c;j+=_142){
_140[_140.length]={"text":j,"value":j,"tooltip":j,"isSmallTick":true};
}
}
}
this._itemData=_140;
return _140;
},_raiseValueChangedServerEvent:function(){
setTimeout(Function.createDelegate(this,function(){
__doPostBack(this._uniqueID);
}),0);
},_onMouseUp:function(evt){
this._trackMouseDownDone=true;
this._incdecreaseMouseDownDone=true;
if(Telerik.Web.UI.RadSlider.DropPending==this){
Telerik.Web.UI.RadSlider.DropPending=null;
if(this._selectstartPending){
$removeHandler(document,"selectstart",this._selectstartHandler);
}
if(this._dragHandleElement){
this._dragHandleElement.blur();
}
if(this._endDragHandleElement){
this._endDragHandleElement.blur();
}
if(this._decreaseHandleElement){
this._decreaseHandleElement.blur();
}
if(this._increaseHandleElement){
this._increaseHandleElement.blur();
}
}
},_onSelectStart:function(evt){
evt.preventDefault();
},_onTrackMouseDown:function(evt){
if(evt.button!=0){
return;
}
var _150=evt.target;
var _151=(_150==this._selectedRegionElement);
var _152=(_150==this._trackElement);
var _153=_150.parentNode;
var _154=(this._listElement)?((_153&&_153==this._listElement)||(_153.parentNode&&_153.parentNode==this._listElement)):false;
if(!_152&&!_151&&!_154){
return;
}
this._animationPending=true;
var _155=(this._isHorizontal)?evt.offsetX:evt.offsetY;
var _156=this._getTrackBounds();
if(_154&&!_152){
var _157=$telerik.getLocation(_150);
var _158=_157[this._getPointProperty()]-_156.x;
if(_158>0){
_155+=_158;
}
}
var _159=0;
if(this._firstValueOffset==0){
_159=this._getHalfDragHandleSize();
}
var _15a=_156.width-_159;
var _15b=this._isSelectionRangeEnabled;
if(_151&&(_15b||(!_15b&&this._isDirectionReversed))){
var _158=this._getElementLocation(this._selectedRegionElement);
_155+=_158;
}
_155=(_155<_159)?_159:(_155>_15a)?_15a:_155;
var _15c=this._handleInSlidingMode=this._getNearestDragHandle(_155);
var _15d=this._updateSelectionStart(_155,_15c);
if(this._largeChange==0){
var _15e=this._calcValue(null,_155,null,_15d);
this._setHandlePosition(_15e,_15c,_15d);
this._handleInSlidingMode=null;
}else{
this._trackMouseDownDone=false;
var _15f=this._isInIncreaseMode(_155,_15d);
var _160=(this._children.get_count()>0&&(this._itemType==Telerik.Web.UI.SliderItemType.Item));
var self=this;
function _tmp(_162){
var _163=self._isInIncreaseMode(_155,_15d);
if(self._trackMouseDownDone||_163!=_15f){
clearTimeout(this._mDownInterval);
self._handleInSlidingMode=null;
self._trackMouseDownDone=true;
return;
}
var _164=self._largeChange;
if(_160){
_164*=2;
}
if(_15f){
_164*=-1;
}
var _165=self._getActiveDragHandleValue(_15d)+_164;
_165=self._calcValue(_165,null,null,_15d);
self._setHandlePosition(_165,_15c,_15d);
self._mDownInterval=setTimeout(_tmp,(_162)?_162:100);
}
_tmp(300);
}
},_onMouseWheel:function(evt){
var _167=this._getTrackBounds();
if(_167.width<1||_167.height<1){
return;
}
this._animationPending=true;
var _168=this._value;
var _169=evt.rawEvent;
var _16a=(_169.wheelDelta)?_169.wheelDelta:_169.detail;
if(Sys.Browser.agent==Sys.Browser.InternetExplorer){
_16a*=-1;
}
var step=this._smallChange;
var _16c=_168+((_16a>0)?step:(-1)*step);
_16c=this._calcValue(_16c,null,null,true);
this._setHandlePosition(_16c,this._dragHandleElement,true);
evt.preventDefault();
},_onDecreaseMouseDown:function(evt){
this._onIncreaseDecreaseMDown(evt,false);
},_onIncreaseMouseDown:function(evt){
this._onIncreaseDecreaseMDown(evt,true);
},_onIncreaseDecreaseMDown:function(evt,_170){
if(evt.button!=0){
return;
}
this._handleInSlidingMode=this._dragHandleElement;
var _171=true;
if(this._isSelectionRangeEnabled&&_170){
this._handleInSlidingMode=this._endDragHandleElement;
_171=false;
}
this._incdecreaseMouseDownDone=false;
this._inSlidingMode=true;
this._valueOnSlideStart=this._getActiveDragHandleValue(_171);
var self=this;
function _tmp(_173){
if(self._incdecreaseMouseDownDone){
self._inSlidingMode=false;
this._handleInSlidingMode=null;
clearTimeout(self._increaseMDownInterval);
if(self._valueOnSlideStart!=self._getActiveDragHandleValue(_171)&&self._autoPostBack){
self._raiseValueChangedServerEvent();
}
return;
}
self._doSmallStep(_170);
self._increaseMDownInterval=setTimeout(_tmp,(_173)?_173:50);
}
_tmp(300);
},add_loaded:function(_174){
this.get_events().addHandler("loaded",_174);
},remove_loaded:function(_175){
this.get_events().removeHandler("loaded",_175);
},add_slideStart:function(_176){
this.get_events().addHandler("slideStart",_176);
},remove_slideStart:function(_177){
this.get_events().removeHandler("slideStart",_177);
},add_slide:function(_178){
this.get_events().addHandler("slide",_178);
},remove_slide:function(_179){
this.get_events().removeHandler("slide",_179);
},add_slideEnd:function(_17a){
this.get_events().addHandler("slideEnd",_17a);
},remove_slideEnd:function(_17b){
this.get_events().removeHandler("slideEnd",_17b);
},add_valueChange:function(_17c){
this.get_events().addHandler("valueChange",_17c);
},remove_valueChange:function(_17d){
this.get_events().removeHandler("valueChange",_17d);
},raise_valueChange:function(_17e,_17f){
_17e=this._getIndexFromValue(_17e);
_17f=this._getIndexFromValue(_17f);
var _180=new Telerik.Web.UI.SliderValueChangeEventArgs(_17e,_17f);
this.raiseEvent("valueChange",_180);
},add_beforeValueChange:function(_181){
this.get_events().addHandler("beforeValueChange",_181);
},remove_beforeValueChange:function(_182){
this.get_events().removeHandler("beforeValueChange",_182);
},raise_beforeValueChange:function(_183,_184){
_183=this._getIndexFromValue(_183);
_184=this._getIndexFromValue(_184);
var _185=new Telerik.Web.UI.SliderBeforeValueChangeEventArgs(_183,_184);
this.raiseEvent("beforeValueChange",_185);
if(_185.get_cancel()){
return true;
}
return false;
},get_activeHandle:function(){
if(!this._liveDrag){
return this._getRelativeLiveDragHandle(this._handleInSlidingMode);
}
return this._handleInSlidingMode;
},get_dragHandles:function(){
return [this._dragHandleElement,this._endDragHandleElement];
},get_value:function(){
return this._getIndexFromValue(this._value);
},set_value:function(_186){
if(this._initialized){
_186=this._getValueFromIndex(_186);
}
this._setNewValue(_186,true);
},get_selectionStart:function(){
return this.get_value();
},set_selectionStart:function(_187){
if(this._isSelectionRangeEnabled){
this.set_value(_187);
}
},get_selectionEnd:function(){
return this._getIndexFromValue(this._selectionEnd);
},set_selectionEnd:function(_188){
if(this._initialized){
_188=this._getValueFromIndex(_188);
}
this._setNewValue(_188,false);
},get_isSelectionRangeEnabled:function(){
return this._isSelectionRangeEnabled;
},set_isSelectionRangeEnabled:function(_189){
this._isSelectionRangeEnabled=_189;
this.updateClientState();
},get_isDirectionReversed:function(){
return this._isDirectionReversed;
},set_isDirectionReversed:function(_18a){
this._isDirectionReversed=_18a;
this.updateClientState();
},get_liveDrag:function(){
return this._liveDrag;
},set_liveDrag:function(_18b){
this._liveDrag=_18b;
this.updateClientState();
},get_minimumValue:function(){
return this._minimumValue;
},set_minimumValue:function(_18c){
if(isNaN(parseInt(_18c,10))){
return;
}
this._minimumValue=_18c;
this.updateClientState();
},get_maximumValue:function(){
return this._maximumValue;
},set_maximumValue:function(_18d){
if(isNaN(parseInt(_18d,10))){
return;
}
this._maximumValue=_18d;
this.updateClientState();
},get_orientation:function(){
return this._orientation;
},set_orientation:function(_18e){
this._orientation=_18e;
this._isHorizontal=(this._orientation==Telerik.Web.UI.Orientation.Horizontal);
this._updateLocationProperty();
this._updateSizeProperty();
this._updatePointProperty();
this.updateClientState();
},get_animationDuration:function(){
return this._animationDuration*1000;
},set_animationDuration:function(_18f){
if(isNaN(parseInt(_18f,10))||_18f<0){
throw Error.argumentOutOfRange("value",_18f,"AnimationDuration should be positive integer");
}
_18f=_18f/1000;
this._animationDuration=_18f;
this._useAnimation=(this._animationDuration>0);
this.updateClientState();
},get_length:function(){
var _190=parseInt((this._isHorizontal)?this._width:this._height);
if(isNaN(_190)){
_190=20;
}
return _190;
},set_length:function(_191){
if(this._isHorizontal){
this.set_width(_191);
}else{
this.set_height(_191);
}
},get_width:function(){
return this._width;
},set_width:function(_192){
if(isNaN(parseInt(_192,10))||_192<1){
throw Error.argumentOutOfRange("value",_192,"Width should be an integer bigger than 1");
}
this._width=_192;
this.updateClientState();
},get_height:function(){
return this._height;
},set_height:function(_193){
if(isNaN(parseInt(_193,10))||_193<1){
throw Error.argumentOutOfRange("value",_193,"Height should be an integer bigger than 1");
}
this._height=_193;
this.updateClientState();
},get_showDecreaseHandle:function(){
return this._showDecreaseHandle;
},set_showDecreaseHandle:function(_194){
this._showDecreaseHandle=_194;
this.updateClientState();
},get_showIncreaseHandle:function(){
return this._showIncreaseHandle;
},set_showIncreaseHandle:function(_195){
this._showIncreaseHandle=_195;
this.updateClientState();
},get_showDragHandle:function(){
return this._showDragHandle;
},set_showDragHandle:function(_196){
this._showDragHandle=_196;
this.updateClientState();
},get_trackMouseWheel:function(){
return this._trackMouseWheel;
},set_trackMouseWheel:function(_197){
this._trackMouseWheel=_197;
this.updateClientState();
},get_largeChange:function(){
return this._largeChange;
},set_largeChange:function(_198){
if(isNaN(parseInt(_198,10))||_198<0){
throw Error.argumentOutOfRange("value",_198,"LargeChange should be positive integer");
}
this._largeChange=_198;
this.updateClientState();
},get_clickOffset:function(){
return this._largeChange;
},set_clickOffset:function(_199){
this.set_largeChange(_199);
},get_slideStep:function(){
return this._smallChange;
},set_slideStep:function(_19a){
this.set_smallChange(_19a);
},get_smallChange:function(){
return this._smallChange;
},set_smallChange:function(_19b){
if(isNaN(parseInt(_19b,10))||_19b<1){
throw Error.argumentOutOfRange("value",_19b,"SmallChange should be integer bigger than 1");
}
this._smallChange=_19b;
this.updateClientState();
},get_itemType:function(){
return this._itemType;
},set_itemType:function(_19c){
this._itemType=_19c;
},get_trackPosition:function(){
return this._trackPosition;
},set_trackPosition:function(_19d){
this._trackPosition=_19d;
},get_visibleItems:function(){
var _19e=this._children;
var _19f=_19e.get_count();
var _1a0=this._isDirectionReversed;
var _1a1=[];
for(var i=0;i<_19f;i++){
var item=_19e.getItem(_1a0?(_19f-1-i):i);
if(item.get_visible()){
Array.add(_1a1,item);
}
}
return _1a1;
},get_items:function(){
var _1a4=this._getChildren();
var _1a5=_1a4.get_count();
var _1a6=this._isDirectionReversed;
var _1a7=[];
for(var i=0;i<_1a5;i++){
var item=_1a4.getItem(_1a6?(_1a5-1-i):i);
Array.add(_1a7,item);
}
return _1a7;
},set_items:function(_1aa){
this._children=_1aa;
},get_itemData:function(){
return this._itemData;
},set_itemData:function(_1ab){
this._itemData=_1ab;
},get_enabled:function(){
return this._enabled;
},set_enabled:function(_1ac){
this._enabled=_1ac;
this.updateClientState();
},Redraw:function(){
this.redraw();
},redraw:function(){
this._inRedrawMode=true;
this._wrapperElement.parentNode.removeChild(this._wrapperElement);
this._wrapperElement=null;
if(this._children){
this._children.clear();
}
this._listElement=null;
this._disposeSlider();
this._initializeLayout();
this._initializeSlider();
this._setNewValue(this._value,true);
if(this._isSelectionRangeEnabled){
this._setNewValue(this._selectionEnd,false);
}
this._createChildControls();
this._inRedrawMode=false;
},saveClientState:function(){
var _1ad=["value","selectionStart","selectionEnd","isSelectionRangeEnabled","enabled","slideStep","clickOffset","trackMouseWheel","showDragHandle","showDecreaseHandle","showIncreaseHandle","length","width","height","animationDuration","minimumValue","maximumValue","orientation","liveDrag","smallChange","trackPosition","largeChange"];
var _1ae={};
for(var i=0;i<_1ad.length;i++){
_1ae[_1ad[i]]=this["get_"+_1ad[i]]();
}
return Sys.Serialization.JavaScriptSerializer.serialize(_1ae);
}};
Telerik.Web.UI.RadSlider.DropPending=null;
Telerik.Web.UI.RadSlider.registerClass("Telerik.Web.UI.RadSlider",Telerik.Web.UI.ControlItemContainer);

